progname=exercise_06_26
CXX=g++
CXXFLAGS=-Wall -Wextra -Werror -std=c++03 -g3

TEST_INPUTS:=$(wildcard test*.input)
SOURCES:=$(wildcard *.cpp)
PREPROCS:=$(patsubst %.cpp,%.ii,$(SOURCES))
ASSEMBLES:=$(patsubst %.cpp,%.s,$(SOURCES))
OBJS:=$(patsubst %.cpp,%.o,$(SOURCES))
TESTS:=$(patsubst %.input,%,$(TEST_INPUTS))

qa: $(TESTS)

test%: $(progname)
	@echo "Running $@..."
	@./$< < $@.input > $@.output || echo "Negative case..."
	@diff $@.output $@.expected > /dev/null && echo "$@ PASSED" || echo "$@ FAILED"

$(progname): $(OBJS) | .gitignore
	$(CXX) $(CXXFLAGS) $^ -o $@

%.ii: %.cpp
	$(CXX) $(CXXFLAGS) -E $< -o $@

%.s: %.ii
	$(CXX) $(CXXFLAGS) -S $< -o $@

%.o: %.s
	$(CXX) $(CXXFLAGS) -c $< -o $@

.gitignore:
	echo $(progname) > $@

clean:
	rm -rf *.ii *.s *.o *.output $(progname)

.PRECIOUS: $(PREPROCS) $(ASSEMBLES)
.SECONDARY: $(PREPROCS) $(ASSEMBLES)

